/* @(#)exception.h
 */

#ifndef _EXCEPTION_H
#define _EXCEPTION_H 1

template <typename T>
class Exception: public std::exception
{
    std::string d_err;
public:
    Exception(std::string const &error);
    virtual char const *what() const throw() override; 
};

template <typename T>
Exception<T>::Exception(std::string const &err)
:
    d_err(err)
{}

template <typename T>
char const *Exception<T>::what() const throw()
{
    return d_err.c_str();
}


#endif /* _EXCEPTION_H */

