#include "picom.ih"

PiCom::Line::Line(int n)
:
    vector<int>(n)
{}

int &PiCom::Line::operator[] (int i)
{
    return vector<int>::operator[](i);
}

int PiCom::Line::operator[] (int i) const
{
    return vector<int>::operator[](i);
}

PiCom::Line::operator int()
{
    if (size() > 1)
        throw Exception<LineError>("Cannot convert a multi-channel line to single channel");
    
    return vector<int>::operator[](0);
}

void PiCom::Line::setChannels(int n)
{
    resize(n);
}

PiCom::Line& PiCom::Line::operator=(int i)
{
    vector<int>::resize(1);
    vector<int>::operator[](0) = i;
    return *this;
}
