#include "picom.ih"

vector<bool> PiCom::listen()
{
    // Wait for other send/receive activity
    while (d_receiving || d_sending) {}

    wait(SRI, 0, 1, -1);

    d_receiving = true;
    vector<bool> ret;
    int nML = d_lines[ML].size();

    for (int channel = 0; channel != nML; ++channel)
    {
        mode(ML, channel, INPUT);
        pull(ML, channel, PUD_DOWN);
    }

    while (true)
    {
        // Listen for chunksize
        int chunkSize = 0;
        while (true)
        {
            sync();
            if (!read(SRI))
                break;
            ++chunkSize;
            sync();
        }
        sync();

        if (chunkSize == 0)
            break;
        else if (chunkSize > nML)
            throw Exception<LineError>("Not enough message-lines available");
        
        // Listen for chunks
        while (true)
        {
            sync(); // wait for all writes
            if (!read(SRI))
                break;

            for (int i = 0; i != chunkSize; ++i)
                ret.push_back(read(ML, i));
            sync();
        }
        sync();
    }

    d_receiving = false;

    return ret;
}
