#include "picom.ih"

PiCom::PiCom(string const &pinFile)
:
    d_lines(N_LINES, Line(1))
{
    try
    {
        loadPins(pinFile);
    }
    catch (string const &err)
    {
        throw Exception<PinFileError>(err);
    }

    wiringPiSetup();
    reset();

    // wait for the connection to be established correctly 
    int inputLines[] =  {SRI, SLI1, SLI2};
    for (int line: inputLines)
        for (size_t channel = 0; channel != d_lines[line].size(); ++channel)
            wait(line, channel, 0, -1);
}
