#include "picom.ih"

void PiCom::send(vector<bool> const &bitstream)
{
    // Wait for other send/receive activity
    while (d_receiving || d_sending) {}

    // Configure message lines
    d_sending = true;
    int nML = channels(ML);
    for (int c = 0; c != nML; ++c)
        mode(ML, c, OUTPUT);

    // Start sending
    int n = bitstream.size();
    int idx = 0;
    while (idx < n)
    {
        int chunkSize = (n - idx >= nML) ? nML : (n - idx);

        // Tell receiver how many channels to read from (= #iterations)
        write(SRO, 1);
        for (int i = 0; i != chunkSize; ++i)
            sync(2);

        write(SRO, 0);
        sync(2);

        // Start sending chunks
        write(SRO, 1);
        while ((idx + chunkSize) <= static_cast<int>(bitstream.size()))
        {
            for (int i = 0; i != chunkSize; ++i)
                write(ML, i, bitstream[idx++]);
            sync(2);
        }
        write(SRO, 0);
        sync(2);
    }
    sync(2);
    
    d_sending = false;
}




