#include "picom.ih"

bool PiCom::wait(int line, int val, int timeout)
{
    static timeval t0, t1, diff;
    gettimeofday(&t0, NULL);

    while (read(line) != val)
    {
        if (timeout > 0) 
        {
            gettimeofday(&t1, NULL);
            timersub(&t1, &t0, &diff);
            if (diff.tv_sec >= timeout)
                return false;
        }
    }
    
    return true;
}

bool PiCom::wait(int line, int channel, int val, int timeout)
{
    static timeval t0, t1, diff;
    gettimeofday(&t0, NULL);

    while (read(line, channel) != val)
    {
        if (timeout > 0) 
        {
            gettimeofday(&t1, NULL);
            timersub(&t1, &t0, &diff);
            if (diff.tv_sec >= timeout)
                return false;
        }
    }
    
    return true;
}





