#include "piftp.ih"

string PiFtp::bits2string(vector<bool> const &bits)
{
    if (bits.size() % 8 != 0)
        throw Exception<InvalidStream>("Number of bits in stream does not align");

    int nBytes = bits.size() / 8;

    string str(nBytes, 0);
    for (int i = 0; i != nBytes; ++i)
    {
        char byte = 0;
        for (int bit = 0; bit != 8; ++bit)
            if (bits[8 * i + bit])
                byte |= (1 << bit);

        str[i] = byte;
    }

    return str;
}
