/* @(#)piftp.h
 */

#ifndef _PIFTP_H
#define _PIFTP_H 1

#include "picom.h"
#include "exception.h"
#include <string>
#include <vector>

class PiFtp
{
    struct NoSuchFile {};
    struct InvalidStream {};

    PiCom d_picom;

public:
    PiFtp(std::string const &pinfile);
    
    void send(std::string const &fname);
    void send(std::string const &source, std::string const &dest);
    void listen();

private:
    static std::vector<bool> string2bits(std::string const &str);
    static std::vector<bool> file2bits(std::string const &fname);

    static std::string bits2string(std::vector<bool> const &bits);
    static void bits2file(std::string const &fname, std::vector<bool> const &bits);
};

#endif /* _PIFTP_H */

