#include "piftp.ih"

void PiFtp::send(string const &fname)
{
    send(fname, fname);
}

void PiFtp::send(string const &source, string const &dest)
{
    timeval t0, t1, diff;
    gettimeofday(&t0, 0);

    d_picom.send(string2bits(dest));
    vector<bool> bitstream = file2bits(source);
    d_picom.send(bitstream);
    d_picom.reset();

    gettimeofday(&t1, 0);
    timersub(&t1, &t0, &diff);
    
    int nbit = bitstream.size();
    double nkbyte = static_cast<double>(nbit) / 8 / 1024;
    double dt = diff.tv_sec + static_cast<double>(diff.tv_usec) / 1e6;
    double rate = nkbyte / dt;
    cout << "Sent file (" << source << ", " << nkbyte << "kb) at " << rate << " kb/s\n";
}
